#include <cex/ansi/codes.h>
#include <cex/test/assert.h>
#include <stdio.h>

void _print_assert(bool success, const char* label, const char* file, size_t line) {
  fprintf(stderr, "%20s: \t%s" ANSI_RESET, label, success ? ANSI_FG_GREEN "OK" : ANSI_FG_RED "FAILED");
  if (!success)
    fprintf(stderr, " in %s on line %ld", file, line);
  putc('\n', stderr);
}

void _print_project_info(test_result_t final_result) {
  int succes_len = INFO_BAR_WIDTH * (final_result.test_count - final_result.fail_count) / final_result.test_count;
  fprintf(stderr, "[");
  for (int i = 0; i < INFO_BAR_WIDTH; i++) {
    fprintf(stderr, "%s ", succes_len > i ? ANSI_BG_GREEN : ANSI_BG_RED);
  }
  fprintf(stderr, ANSI_RESET "]\n");

  fprintf(stderr, "%ld / %ld " ANSI_FG_GREEN " succesful" ANSI_RESET ", %ld " ANSI_FG_RED "failed\n" ANSI_RESET,
          final_result.test_count - final_result.fail_count, final_result.test_count, final_result.fail_count);
}